#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <string.h>

static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

/* ======================================================================== *\
\*                                                                 XsStruct */

typedef
struct __CStruct
{
  char *name;
  int   num;
} CStruct;

void setName(CStruct *s, char *n)
{
  if (s != NULL)
  {
    if (s->name != NULL) { free(s->name); }
    s->name = (n != NULL) ? strdup(n) : NULL;
  }
}


MODULE = c_struct		PACKAGE = c_struct		

CStruct *
createStruct(name, num)
	char* name
	int   num
	CODE:
		CStruct *s = (CStruct*) malloc(sizeof(CStruct));
                s->name = NULL;
		setName(s, name);
		s->num  = num;
		RETVAL  = s;
	OUTPUT:
	RETVAL

void
deleteStruct(s)
	CStruct* s
	CODE:
		if (s != NULL)
		{
		  if (s->name != NULL) { free(s->name); }
		  free(s);
		}

void
setName(s, name)
	CStruct*   s
	char*      name

char*
getName(s)
	CStruct* s
	CODE:
		if (s != NULL)
		{
		  RETVAL = s->name;
		}
                else
                {
		  RETVAL = "";
		}  
        OUTPUT:
        RETVAL

void
setNum(s, num)
	CStruct* s
	int        num
	CODE:
		if (s != NULL)
		{
		  s->num = num;
		}

int
getNum(s)
	CStruct* s
	CODE:
		if (s != NULL)
		{
		  RETVAL = s->num;
		}
                else
                {
		  RETVAL = 0;
		}  
        OUTPUT:
        RETVAL
